## 3.51.1
### New
1. `captureDetectHowling` warning is added into [MediaDeviceWarning](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_media_defines/MediaDeviceWarning.html), which will be triggered in the following circumstances:
    - Howling is detected in room modes that do not support howling suppression.
    - Unsuppressed howling is detected in room modes that support howling suppression.
2. From iPadOS, you can use Stage Manger to organize Apps and Windows. If your App is not in the center, you can get informed by [onVideoDeviceStateChanged](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onVideoDeviceStateChanged.html). Refer to [Resume Audio/Video Call](https://docs.byteplus.com/en/byteplus-rtc/docs/111590).
3. Set a static picture as a replacement for the locally captured video stream by calling the new API [setDummyCaptureImagePath](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setDummyCaptureImagePath.html).
4. Switch the BlueTooth communication mode between the iOS device and earphones when RTC works on media scenarios by calling the new API [setBluetoothMode](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setBluetoothMode.html).
5. In multi-room scenarios, you can adjust the volume of all users in one room at once with the new API [setRemoteRoomAudioPlaybackVolume](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_room_api/RTCRoom/setRemoteRoomAudioPlaybackVolume.html).
6. By calling the new API [setNoAttenuationFlags](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_range_audio_api/RTCRangeAudio/setNoAttenuationFlags.html), you can set a team to the mode that the teammates can talk without attenuation, despite the range audio feature being enabled.
7. Supports detecting background music during the call and protecting the sound quality of the music. Please contact the technical support team if you need this feature.
8. Adds [onPublishPrivilegeTokenWillExpire](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_room_event_handler/RTCRoomEventHandler/onPublishPrivilegeTokenWillExpire.html) and [onSubscribePrivilegeTokenWillExpire](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_room_event_handler/RTCRoomEventHandler/onSubscribePrivilegeTokenWillExpire.html) callbacks, which will be triggered when the publishing/subscribing privilege of your Token is about to expire. After receiving the callback, you must re-acquire and update the relevant privileges of the Token to ensure normal audio/video calls. Contact the technical support team if you need this feature.
9. Supports some new voice reverb types. For all the types, see [VoiceReverbType](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_audio_defines/VoiceReverbType.html).
10. Supports setting the equalization and reverb effect of the locally captured audio. See the APIs below:
    - [setLocalVoiceEqualization](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setLocalVoiceEqualization.html)
    - [setLocalVoiceReverbParam](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setLocalVoiceReverbParam.html)
    - [enableLocalVoiceReverb](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/enableLocalVoiceReverb.html)
11. Supports stopping, pausing, and resuming playback of all audio files. See the APIs below:
    - [stopAllAudioMixing](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_audio_mixing_api/RTCAudioMixingManager/stopAllAudioMixing.html)
    - [pauseAllAudioMixing](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_audio_mixing_api/RTCAudioMixingManager/pauseAllAudioMixing.html)
    - [resumeAllAudioMixing](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_audio_mixing_api/RTCAudioMixingManager/resumeAllAudioMixing.html)
12. Supports examining the echo-cancellation ability of local audio devices before or during an RTC call. See the APIs below:
    - [startHardwareEchoDetection](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/startHardwareEchoDetection.html)
    - [stopHardwareEchoDetection](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/stopHardwareEchoDetection.html)
13. Adds a new feature allowing users to magnify the view of local videos and then move around. We recommend this feature as the method for local video control by considering the diversity of cameras on all the devices and the difficulties of adapting them all. See the APIs below:
    - [setVideoDigitalZoomConfig](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setVideoDigitalZoomConfig.html)
    - [setVideoDigitalZoomControl](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setVideoDigitalZoomControl.html)
    - [startVideoDigitalZoomControl](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/startVideoDigitalZoomControl.html)
    - [stopVideoDigitalZoomControl](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/stopVideoDigitalZoomControl.html)
14. Automatically adapt the Ambient Noise Suppression(ANS) algorithm according to the business scenario selected when entering the room by calling the new API [setAnsMode](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setAnsMode.html). You can also set the ANS mode manually during the call. 
15. Adjust the volume of the remote public audio for local playback by calling the new API [setPublicStreamAudioPlaybackVolume](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setPublicStreamAudioPlaybackVolume.html).

### Enhanced
1. When getting local and remote volume information by calling [enableAudioPropertiesReport](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/enableAudioPropertiesReport.html), you can make the volume curve smoother with "smooth" and get information about locally mixing audio with "audio_report_mode".

2. [sendSEIMessage](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/sendSEIMessage.html) includes a new parameter "SEICountPerFrame". When you send multiple SEI messages in 1 frame, they will be sent together in the next frame.

### Changelog
#### Header file change
The original header file "bytertc_common_defines.dart" is split into "bytertc_media_defines.dart" and "bytertc_rts_defines.dart", both of which you should import into your project if needed.
#### API change
1. [registerFaceDetectionObserver](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/registerFaceDetectionObserver.html) is replaced by [enableFaceDetection](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/enableFaceDetection.html) and [disableFaceDetection](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/disableFaceDetection.html), decoupling face detection and video effects to improve usability.
2. The parameter type of [setScreenVideoEncoderConfig](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setScreenVideoEncoderConfig.html) changes from "VideoEncoderConfig" to "ScreenVideoEncoderConfig".
3. Video effect related APIs are moved from `RTCVideo` class to `RTCVideoEffect` class:
    - [initCVResource](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/initCVResource.html) replaces [checkVideoEffectLicense](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/checkVideoEffectLicense.html) and [setVideoEffectAlgoModelPath](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setVideoEffectAlgoModelPath.html)；
    - [enableVideoEffect](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/enableVideoEffect.html) and [disableVideoEffect](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/disableVideoEffect.html) replace [enableVideoEffect](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/enableVideoEffect.html)；
    - [setEffectNodes](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/setEffectNodes.html) replaces [setVideoEffectNodes](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setVideoEffectNodes.html)；
    - [updateEffectNode](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/updateEffectNode.html) replaces [updateVideoEffectNode](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/updateVideoEffectNode.html)；
    - [enableVirtualBackground](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/enableVirtualBackground.html) and [disableVirtualBackground](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/disableVirtualBackground.html) replace [setBackgroundSticker](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setBackgroundSticker.html)；
    - [setColorFilter](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/setColorFilter.html) replaces [setVideoEffectColorFilter](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setVideoEffectColorFilter.html)；
    - [setColorFilterIntensity](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_effect_api/RTCVideoEffect/setColorFilterIntensity.html) replaces [setVideoEffectColorFilterIntensity](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setVideoEffectColorFilterIntensity.html)；
4. Return value type change:
    - The return type of the following APIs is changed to "int", the values of which are listed in [ReturnStatus](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_media_defines/ReturnStatus.html): `updateToken`，`setRemoteVideoConfig`，`subscribeStream`，`unsubscribeStream`，`subscribeScreen`，`unsubscribeScreen`，`setVoiceChangerType`，`setVoiceReverbType`；
    - The return type of the following APIs is changed to "void": `setMultiDeviceAVSync`，`setLocalVideoMirrorType`，`setVideoRotationMode`，`setAudioRoute`，`enableSimulcastMode`，`setPublishFallbackOption`，`setSubscribeFallbackOption`.
5. `getSdkVersion` is changed to [getSDKVersion](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/getSDKVersion.html).
6. The behavior of [setAudioRoute](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/setAudioRoute.html) changed. You can use devices with media mode only as the audio route device.

#### Callback change
1. [onPublicStreamSEIMessageReceived](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onPublicStreamSEIMessageReceived.html) includes a new parameter "sourceType".
2. The `RTCRangeAudioObserver` callback class is deprecated. Before this version, When you use range audio with manual audio subscription, you must set the attenuation index based on the return value of "RTCRangeAudioObserver". From this version, you can set the attenuation model by calling [setAttenuationModel](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_range_audio_api/RTCRangeAudio/setAttenuationModel.html).
3. [onRemoteAudioStateChanged](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onRemoteAudioStateChanged.html) and [onRemoteVideoStateChanged](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onRemoteVideoStateChanged.html) are deprecated with no alternatives.
4. [onLocalAudioStateChanged](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onLocalAudioStateChanged.html) and [onLocalVideoStateChanged](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onLocalVideoStateChanged.html) are replaced by [onAudioDeviceStateChanged](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onAudioDeviceStateChanged.html) and [onVideoDeviceStateChanged](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onVideoDeviceStateChanged.html).

#### Class/Enum change
1. [FaceDetectionResult](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_defines/FaceDetectionResult-class.html) includes a new member "frameTimestampUs".
2. [UserMessageSendResult](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_rts_defines/UserMessageSendResult.html) includes a new value "exceedQPS".
3. [RoomMessageSendResult](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_rts_defines/RoomMessageSendResult.html) includes a new value "exceedQPS".
4. The type of the variables in [Position](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_audio_defines/Position-class.html) representing spatial coordinates in spatial audio functions changes from "int" to "double".
5. The configuration of the default mode "communication" in [RoomProfile](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_media_defines/RoomProfile.html) changes from corresponding to "chatRoom" to corresponding to "meeting".
6. The type of the `errorCode` in [onPushPublicStreamResult](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onPushPublicStreamResult.html) and [onPlayPublicStreamResult](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_event_handler/RTCVideoEventHandler/onPlayPublicStreamResult.html) changes from "int" to [PublicStreamErrorCode](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_media_defines/PublicStreamErrorCode.html).
7. The value "unknown" in [AudioRoute](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_audio_defines/AudioRoute.html) is changed to "routeDefault".
8. [AudioScenario](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_audio_defines/AudioScenario.html) The mapping of audio routing and publish-subscribe state to volume type has changed. See the documentation of the data structure for the latest mapping.

## 3.45.2
### New
1. [AudioScenario](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_audio_defines/AudioScenario.html) includes "highQualityChat" mode.
2. Get the actual mixing length of the audio file by calling the new API [getAudioMixingPlaybackDuration](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_audio_mixing_api/RTCAudioMixingManager/getAudioMixingPlaybackDuration.html), regardless of pausing, jumping, changing speed, and stuck.
3. With the new pair of APIs [subscribeAllStreams](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_room_api/RTCRoom/subscribeAllStreams.html) and [unsubscribeAllStreams](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_room_api/RTCRoom/unsubscribeAllStreams.html), you can subscribe or unsubscribe to all users by one call. We recommend using them in the scenario that requires a fixed number of publishers.
4. Set the default volume during audio mixing on mobile with the new API [setAllAudioMixingVolume](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_audio_mixing_api/RTCAudioMixingManager/setAllAudioMixingVolume.html).
5. Get the snapshot of the local/remote screen on the client with the new APIS [takeLocalSnapshot](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/takeLocalSnapshot.html) and [takeRemoteSnapshot](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_video_api/RTCVideo/takeRemoteSnapshot.html).
6. [NetworkQuality](https://pub.dev/documentation/byteplus_rtc/latest/api_bytertc_common_defines/NetworkQuality.html) includes a new value "down" which can reflect the disconnection status of the local network.

## 3.45.1

* Fixed a few bugs.

## 3.44.1

* Flutter for BytePlusRTC SDK release.